

/*
 * Channel.java
 *
 * Created on 8 de Maio de 2006, 14:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.blocking;


import java.io.DataOutputStream;
import java.util.concurrent.Semaphore;

/**
 *
 * @author edualchieri
 */
public class SynchronizedOutput {
    
    public Semaphore sm = new Semaphore(1);
    private DataOutputStream out;
    private ConnectionManager manager;
    private int target;
    private boolean closed;
    /** Creates a new instance of Channel */
    public SynchronizedOutput(DataOutputStream out, ConnectionManager manager, int target) {
        this.out = out;
        this.manager = manager;
        this.target = target;
        this.closed = false;
    }
    
    public void write(byte[] msg){
        //br.ufsc.das.util.Logger.println("(SynchOutput) Ah espera do semaforo para escrever ");
        try{
            
            this.sm.acquire();
            if (!closed){
                //br.ufsc.das.util.Logger.println("(SynchOutput) Passei o semaforo, vou escrever, a enviar tamanho = "+msg.length);
                out.writeInt(msg.length);
                //br.ufsc.das.util.Logger.println("(SynchOutput) a enviar msg");
                out.write(msg);
                //br.ufsc.das.util.Logger.println("(SynchOutput) a fazer flush");
                out.flush();
                //br.ufsc.das.util.Logger.println("(SynchOutput) Escrevi tudo, vou libertar o semaforo ");
            }
            this.sm.release();
        }catch(Exception e){
           
            
            try{
                out.close();
                closed = true;
            }catch(Exception ignore){
                
            }
            
            this.sm.release();
            
            System.out.println("(SynchronizedOutput) Erro ao enviar: ");
            e.printStackTrace(System.out);
        }
    }
}
